
import("util.FGCargoMonitor", "FGCargoMonitor", 1);

class FGCargoMonitorTeszt extends GSController {
	cargoMonitor = null;
	companies = null;
	game_ended = false;
	constructor() {
		
		/*
		 *	Create the instance
		 */
		this.cargoMonitor = FGCargoMonitor(this, FGCargoMonitor.LOGLEVEL_ALL);
		
		
		this.companies = [];
		this.game_ended = false;
	}
}

function FGCargoMonitorTeszt::Start() {
	this.Sleep(1);
	while (true) {
		local ticks = GSController.GetTick();
		
		if (!this.game_ended) {
			this.HandleEvents();
			
			
			/*
			 *	You need Upate the monitor to keeping your updated :D
			 */
			this.cargoMonitor.Update();
		}
		
		
		local ticks_used = GSController.GetTick() - ticks;
		local day = 1;
		this.Sleep((day * 74) - ticks_used);
	}
}

function FGCargoMonitorTeszt::HandleEvents() {
	if (GSEventController.IsEventWaiting()) {
		local ev = GSEventController.GetNextEvent();
		
		switch (ev.GetEventType()) {
			case GSEvent.ET_COMPANY_NEW:
				// get company_id
				local ainstance = GSEventCompanyNew.Convert(ev);
				local company_id = ainstance.GetCompanyID();
				if (company_id == GSCompany.COMPANY_INVALID)
					break;
				
				// random cargo type:
				local cargo_ids = [];
				local cargos = GSCargoList();
				foreach (cargo_id, _ in cargos) {
					cargo_ids.append(cargo_id);
				}
				
				local cargo_id;
				
				local town_id = null;
				local counter = 0;
				
				local ind_prod_id = null;
				local ind_acce_id = null;
				
//				while (ind_prod_id == null || ind_acce_id == null) {
				do {
					cargo_id = GSBase.RandRange(cargo_ids.len());
					local industries_prod = GSIndustryList_CargoProducing(cargo_id);
					local industries_acce = GSIndustryList_CargoAccepting(cargo_id);
					if (industries_prod.Count() > 0 && industries_acce.Count() > 0) {
						local ind_ar = [];
						foreach (ind_id, _ in industries_prod) {
							ind_ar.append(ind_id);
						}
						ind_prod_id = ind_ar[GSBase.RandRange(ind_ar.len())];
						
						ind_ar.clear();
						foreach (ind_id, _ in industries_acce) {
							ind_ar.append(ind_id);
						}
						ind_acce_id = ind_ar[GSBase.RandRange(ind_ar.len())];
						
						if (!GSIndustry.IsValidIndustry(ind_prod_id))
							ind_prod_id = null;
						
						if (!GSIndustry.IsValidIndustry(ind_acce_id))
							ind_acce_id = null;
					}
					
					if (ind_prod_id != null && ind_acce_id != null)
						town_id = GSTile.GetTownAuthority(GSIndustry.GetLocation(ind_prod_id));
//						town_id = GSTile.GetTownAuthority(GSIndustry.GetLocation(ind_acce_id));
					
					counter++;
				}
				while (counter < 100 && (town_id == null || !GSTown.IsValidTown(town_id)))

				// random amount
				local amount = GSBase.RandRange(50 - 30) + 30 + 1; // GSBase.RandRange(amountMax - amountMin) + amountMin + 1;
				local amount2 = GSBase.RandRange(121 - 111) + 111 + 1; // GSBase.RandRange(amountMax - amountMin) + amountMin + 1;
				
				// create new goal
				local goal_id = GSGoal.New(company_id, "Transport " + amount + " of " + GSCargo.GetCargoLabel(cargo_id) + " from town: " + GSTown.GetName(town_id), GSGoal.GT_TOWN, town_id);
				local goal_id2 = GSGoal.New(company_id, "Transport " + amount2 + " of " + GSCargo.GetCargoLabel(cargo_id) + " from industry: " + GSIndustry.GetName(ind_prod_id), GSGoal.GT_INDUSTRY, ind_prod_id);
				
				
				/*
				 *	Subscribe to cargo delivery and/or pickup monitoring
				 */
				// subscribe to monitor // REFRESH_IMMEDIATELY REFRESH_EVERY_MONTHS REFRESH_EVERY_QARTER_YEARS REFRESH_EVERY_HALF_YEARS REFRESH_EVERY_YEARS
//				this.cargoMonitor.SubscribeToMonitor(company_id, cargo_id, goal_id, FGCargoMonitor.REFRESH_IMMEDIATELY, FGCargoMonitor.MONITOR_ALL, null);
//				this.cargoMonitor.SubscribeToMonitor(company_id, cargo_id, goal_id, FGCargoMonitor.REFRESH_IMMEDIATELY, FGCargoMonitor.MONITOR_ALL_DELIVERY, null);
				this.cargoMonitor.SubscribeToMonitor(company_id, cargo_id, goal_id, FGCargoMonitor.REFRESH_IMMEDIATELY, FGCargoMonitor.MONITOR_ALL_PICKUP, null);
//				this.cargoMonitor.SubscribeToMonitor(company_id, cargo_id, goal_id, FGCargoMonitor.REFRESH_IMMEDIATELY, FGCargoMonitor.MONITOR_TOWN_DELIVERY, town_id);
//				this.cargoMonitor.SubscribeToMonitor(company_id, cargo_id, goal_id, FGCargoMonitor.REFRESH_IMMEDIATELY, FGCargoMonitor.MONITOR_TOWN_PICKUP, town_id);
//				this.cargoMonitor.SubscribeToMonitor(company_id, cargo_id, goal_id, FGCargoMonitor.REFRESH_IMMEDIATELY, FGCargoMonitor.MONITOR_INDUSTRY_DELIVERY, ind_acce_id);
				this.cargoMonitor.SubscribeToMonitor(company_id, cargo_id, goal_id2, FGCargoMonitor.REFRESH_IMMEDIATELY, FGCargoMonitor.MONITOR_INDUSTRY_PICKUP, ind_prod_id);
				
				
				
				// add company to list
				this.companies.append({company_id = company_id, goal_id = goal_id, win_amount = amount, transported_amount = 0});
				this.companies.append({company_id = company_id, goal_id = goal_id2, win_amount = amount2, transported_amount = 0});
				
				break;
				
				
			case GSEvent.ET_COMPANY_BANKRUPT:
				local instance = GSEventCompanyBankrupt.Convert(ev);
				local company_id = instance.GetCompanyID();
				if (company_id == GSCompany.COMPANY_INVALID) break;
				
				// remove the bankrupted company
				for (local i = 0; i < this.companies.len(); i++) {
					if (this.companies[i].company_id == company_id) {
						this.companies.remove(i);
						break;
					}
				}
				
				
				/*
				 *	Unsubscribe the all goal of company
				 */
				this.cargoMonitor.UnSubscribeCompanyFromMonitor(company_id);
				break;
				
				
			case GSEvent.ET_COMPANY_MERGER:
				local instance = GSEventCompanyMerger.Convert(ev);
				local company_id = instance.GetOldCompanyID();
				if (company_id == GSCompany.COMPANY_INVALID) break;
				
				// remove the merged company
				for (local i = 0; i < this.companies.len(); i++) {
					if (this.companies[i].company_id == company_id) {
						this.companies.remove(i);
						break;
					}
				}
				
				
				/*
				 *	Unsubscribe the all goal of company
				 */
				this.cargoMonitor.UnSubscribeCompanyFromMonitor(company_id);
				break;
		}
	}
}

/*
 *	You need to subscribe this delegate method
 *
 */
function FGCargoMonitorTeszt::SendCargoUpdate(company_id, goal_id, transported) {
	GSLog.Info(GSCompany.GetName(company_id) + " transported: " + transported + " (goal_id: " + goal_id + ")");
	foreach (company in this.companies) {
		if (company.company_id == company_id && company.goal_id == goal_id) {
			company.transported_amount += transported;
			local progress = ((company.transported_amount * 100) / company.win_amount).tointeger();
			if (progress > 100)
				progress = 100;
			if (GSController.GetVersion() > 321414176)
				GSGoal.SetProgress(goal_id, progress.tostring() + "%");
			else
				GSLog.Info(GSCompany.GetName(company_id) + " progress of goal: " + progress + "%");
			
			if (company.transported_amount >= company.win_amount) {
				
				/*
				 *	Unsubscribe from goal
				 */
				this.cargoMonitor.UnSubscribeFromMonitor(company_id, goal_id);
				
				
				if (GSController.GetVersion() > 321414176)
					GSGoal.SetCompleted(goal_id, true);
				
				for (local i = 0; i < this.companies.len(); i++) {
					if (this.companies[i].company_id == company_id && this.companies[i].goal_id == goal_id) {
						this.companies.remove(i);
						break;
					}
				}
				local van = false;
				foreach (company in this.companies) {
					if (company.company_id == company_id) {
						van = true;
						break;
					}
				}
				
				if (!van) {
					
					/*
					 *	Unsubscribe from all monitoring at game end
					 */
					this.cargoMonitor.UnSubscribeAllFromMonitor();
					
					
					GSGoal.Question(0, GSCompany.COMPANY_INVALID, GSCompany.GetName(company_id) + " win the game!", GSGoal.QT_INFORMATION, GSGoal.BUTTON_CLOSE);
					this.game_ended = true;
				}
			}
			break;
		}
	}
}

function FGCargoMonitorTeszt::Save() {
	return {
		game_ended = this.game_ended,
		companies = this.companies,
		
		/*
		 *	Save with one function
		 */
		cargoMonitor = this.cargoMonitor.SaveData(),
	}
}

function FGCargoMonitorTeszt::Load(version, table) {
	this.game_ended = table.game_ended;
	this.companies = table.companies;
	
	/*
	 *	Load also with one function
	 */
	this.cargoMonitor.LoadFromData(table.cargoMonitor);
}
